# Asyril Devices CBun
 
The Asyril Devices CBun serves as an interface for controlling the Asyril EYE+ Vision Solution. The Eye+ CBun device empowers robot programmers to initiate object detection, retrieve object coordinates, and provides methods that allows to perform camera calibration within a robot program. 

The Eye+ CBun device support is implemented in form of **AsyrilEyep** class which is inherited from the `kr2_bundle_api::CustomDevice` class. The communication with the camera is facilitated through TCP/IP using standard C++ sockets.

## Git Clone on Windows

When using `git clone` command on Windows, the git may convert Unix-style `\n` line breaks to Windows-style `\r\n` line breaks on checking files out. Since the CBun build container is Unix based, this automatic line break conversion may cause issues during the CBun development. Therefore make sure that this behaviour is disabled prior cloning this CBun example project by running the following command: 

`git config --global core.autocrlf false`

## Build Environment

The Asyril Devices CBuns comes with the preconfigured CBun build environment which is base on the **Visual Studio Code Dev Containers** extension. With this you can open, debug and build the CBun project in Visual Studio Code on Windows, MacOS or Linux without the need for complicated build environment configuration. 

### Prerequisities

To get started, follow these steps:

1. Install and configure [Docker](https://www.docker.com/get-started) for your operating system, using one of the paths below.

   **Windows / macOS:**

   1. Install Docker [Desktop for Windows/Mac](https://www.docker.com/products/docker-desktop).

   2. If you are using Windows, enable WSL and make sure it is up to date by running the following Command Prompt: `wsl --update`

   **Linux:**

   1. Follow the [official install instructions for Docker CE/EE for your distribution](https://docs.docker.com/install/#supported-platforms).

   2. Add your user to the docker group by using a terminal to run: `sudo usermod -aG docker $USER`

   3. Sign out and back in again so your changes take effect.

2. Install [Visual Studio Code](https://code.visualstudio.com/) release 1.85 from [here](https://code.visualstudio.com/updates/v1_85)*.

3. Install the [Dev Containers extension](https://marketplace.visualstudio.com/items?itemName=ms-vscode-remote.remote-containers). 

\* *Starting with VSCode release 1.86, the CBun Docker container does not meet the minimum requirements for the build tool chain of the remote VSCode server. To continue using CBun build environment, downgrade the VS Code to version 1.85. Depending on your platform, make sure to disable updates to stay on that version.*

### CBun Project Setup

To setup the CBun project in Visual Studio Code, follow these steps:

1. Open your CBun project folder in Visual Studio Code.

2. Click **Yes, I trust the authors**.

3. Click **Reopen in Container** (this may take few minutes).

5. Select the **GCC 8.4.0 x86_64-linux-gnu** as the active Kit.

### CBun Tasks

Finally you can run the following tasks from the Visual Studio Code:

* **CBun: Build** - Builds and assembles your CBun from sources into the `build/asyril_devices.cbun` file.

* **CBun: Build and Install** - Builds and installs your CBun (for integration tests only)

## CBun Assembly

The CBun installer (asyril_devices.cbun) is generated by the **CBun: Build** task in Visual Studio Code if the **Release** build variant is selected. Once the CBun is generated, it can be installed on the real robot from a USB stick or Google Drive.

Follow the steps bellow in order to generate and install the CBun:

1. Open the backend project in Visual Studio Code. 

2. Set **Release** build variant.

3. Run the **CBun: Build** task (**Terminal** -> **Run Task...** -> **CBun: Build**).

4. Copy the CBun installer (**PROJECT_FOLDER/build/asyril_devices.cbun**) to a USB stick.

5. Install the CBun on a real robot from the USB stick.

